.\"	$NetBSD: guspnp.4,v 1.15 2008/04/30 13:10:54 martin Exp $
.\"
.\" Copyright (c) 1999 The NetBSD Foundation, Inc.
.\" All rights reserved.
.\"
.\" This code is derived from software contributed to The NetBSD Foundation
.\" by Kari Mettinen.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
.\" ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd June 22, 2005
.Dt GUSPNP 4
.Os
.Sh NAME
.Nm guspnp
.Nd Am78C201 audio device driver
.Sh SYNOPSIS
.Cd "guspnp* at isapnp?"
.Cd "audio*  at audiobus?"
.Pp
There should be no limit caused by the driver on the number of drivers
or cards active in the system.
.Sh DESCRIPTION
The
.Nm guspnp
driver provides support for audio subsystems using the Interwave (Am78C20x)
family of ICs, usually the Gravis Ultrasound Plug and Play.
Unlike the
.Nm gus
driver guspnp driver does not require any local memory for the IC, but uses
the codec for both playback and recording.
The
.Nm guspnp
driver can simultaneously playback and record 8- and 16-bit samples at
frequencies from 5.51kHz to 48kHz.
.Pp
The
.Nm guspnp
driver relies on
.Nm isapnp
to allocate suitable resources for it.
This version of the driver only
uses the first logical device of the five the Interwave IC has.
The four unused
logical devices are the ATAPI CD-ROM device, PnP Joystick device, legacy
soundcard emulation device (SoundBlaster) and MIDI serial device.
Support
for at least ATAPI CD-ROM and Joystick is being worked on.
This version of the driver will use 1 IRQ and 2 DRQs.
.Sh HARDWARE
Cards supported by the
.Nm
driver include:
.Pp
.Bl -item -offset indent
.It
.Tn Gravis
Ultrasound PNP, and compatibles
.El
.Sh SEE ALSO
.Xr audio 4 ,
.Xr gus 4 ,
.Xr isapnp 4
.Sh REFERENCES
Interwave(tm) IC Am78C201/202 Programmer's Guide Rev. 2. 1996. Advanced
Micro Devices.
.Sh HISTORY
The
.Nm guspnp
driver appeared in
.Nx 1.3 .
.Sh AUTHORS
.An Kari Mettinen Aq Kari.Mettinen@helsinki.fi ,
University of Helsinki.
.Sh BUGS
Sometimes you can cause a hiss on either left or right channel, or both.
You can usually make it disappear by playing random data, however this
might not be a very nice thing to your audio equipment, but it is the only
way I have found out to be effective.
.Pp
Only the Codec is used in this version of the driver, therefore only 2
channels are supported (left and right). Also sound quality is probably
worse at lower kHz compared to playing through the synthesizer which does
interpolation.
.Pp
If the implementation has a 'bad' oscillator, using frequencies 44.8kHz
and 38.4kHz will result in incorrect playback frequency. The author has
a GUS PnP Pro which displays this behavior.
.Pp
Other members of the Interwave family have not been tested and don't
have the glue needed to make them work. Should someone need to implement it,
not many changes in the existing code are needed.
Output voltage control in
register CFIG2 [7] should be set differently for some other members of the
family.
.Pp
Other architectures than i386 haven't been tested. The bus_space abstraction
has been used from the beginning, so it should work.
